"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const format_1 = require("@cybernaut/utils/lib/format");
class Describable {
    constructor(description) {
        this.description = description;
        const blacklist = new Set(['describeMethodCall', 'description']);
        return new Proxy(this, {
            get: (target, property) => {
                if (typeof property === 'string' && !blacklist.has(property)) {
                    target.description = `${description}.${property}`;
                }
                return target[property];
            }
        });
    }
    /* tslint:disable-next-line no-any */
    describeMethodCall(...args) {
        return `${this.description}(${args.map(format_1.format).join(', ')})`;
    }
}
exports.Describable = Describable;
//# sourceMappingURL=Describable.js.map