"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const deepStrictEqual = require("deep-strict-equal");
const Describable_1 = require("./Describable");
class GenericConditionBuilder extends Describable_1.Describable {
    constructor(description, accessor, negated) {
        super(description);
        this.accessor = accessor;
        this.negated = negated;
    }
    equalTo(value) {
        const description = this.describeMethodCall(...arguments);
        return this.condition(description, actualValue => {
            if (actualValue !== actualValue && value !== value) {
                return true;
            }
            return deepStrictEqual(actualValue, value);
        });
    }
    condition(description, predicate) {
        const { accessor, negated } = this;
        return { description, accessor, predicate, negated };
    }
}
exports.GenericConditionBuilder = GenericConditionBuilder;
//# sourceMappingURL=GenericConditionBuilder.js.map