"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const GenericConditionBuilder_1 = require("./GenericConditionBuilder");
class NumberConditionBuilder extends GenericConditionBuilder_1.GenericConditionBuilder {
    constructor(description, accessor, negated) {
        super(description, accessor, negated);
    }
    above(value) {
        const description = this.describeMethodCall(...arguments);
        return this.condition(description, actualValue => actualValue > value);
    }
    atLeast(value) {
        const description = this.describeMethodCall(...arguments);
        return this.condition(description, actualValue => actualValue >= value);
    }
    atMost(value) {
        const description = this.describeMethodCall(...arguments);
        return this.condition(description, actualValue => actualValue <= value);
    }
    below(value) {
        const description = this.describeMethodCall(...arguments);
        return this.condition(description, actualValue => actualValue < value);
    }
    between(minValue, maxValue) {
        const description = this.describeMethodCall(...arguments);
        return this.condition(description, actualValue => actualValue >= minValue && actualValue <= maxValue);
    }
}
exports.NumberConditionBuilder = NumberConditionBuilder;
//# sourceMappingURL=NumberConditionBuilder.js.map